/* EX22_1
 Problema: Escrever um programa em C que faa reserva de passagens aereas de
 uma companhia. Alem da leitura do numero dos voos e da quantidade de lugares
 disponiveis, ler varios pedidos de reserva, constituidos do numero da carteira
 de identidade e do nome do cliente, do numero do voo desejado. Para cada
 cliente, verificar se ha disponibilidade no voo desejado. Em caso afirmativo
 imprimir o numero da carteira de identidade e do nome do cliente, o numero do
 voo , atualizando o numero de lugares disponiveis. Caso contrario, avisar ao
 cliente da inexistencia de lugares. O programa deve mostrar uma mensagem do
 tipo <Enter>- para digitar pedidos, e <Esc>-para finalizar. Considere fixo e
 igual a 30 o numero de voos da companhia.

Resolucao: O programa deve ter os seguintes passos:
  1 - definir os tipos de dados; (declarar as variaveis)
  2 - permitir que voce digite o numero efetivo de voos (valor de "n");
  3 - executar menu - opo digitada pelo usurio
      3.1 - repeticao para:
            3.1.1 - ler os numeros dos voos existentes, um de cada vez;
            3.1.2 - ler a quantidade de lugares disponiveis nos voos;
      
      3.2 - repeticao para atender os clientes:
            3.2.1 - ler o numero da identidade do cliente;
            3.2.2 - ler o nome de um cliente;
            3.2.3 - ler o numero do voo desejado;
            3.2.4 - verificar a existencia do voo?
                    3.2.4.1 - guardar o indice da posicao do voo (vetNumVoo);
                    3.2.4.2 - ou mostrar a mensagem: voo inexistente;
            3.2.5 - verificar disponibilidade de lugares no voo?
                    3.2.5.1 - Reservar passagem;
                    3.2.5.2 - atualizar numero de lugares disponiveis;
                    3.2.5.3 - ou mostrar a mensagem: voo lotado;
            3.2.6 - mostrar a mensagem: Deseja atender outro cliente ? 
                                        Tecle <Enter> - para Sim, ou 

                                         <Esc> - para No.

descricao das variaveis
  n - numero efetivo de voos - numero de repeticoes
  i - contador de repeticao (indice - controlador da repeticao)
  vetVoo - vetor com os numeros dos voos existentes
  vetListDisp - vetor com a quantidade de lugares disponiveis nos voos
  identClient - numero da identidade do cliente
  nomeClient - nome de um cliente
  numVoo - numero do voo desejado
  apont - indice da posicao do voo desejado
  opcao - menu - opo digitada pelo usurio

*/

#include <stdio.h>  /* arquivo de inclusao para entrada e saida, para usar: scanf e printf */
#include <conio.h>  /* para usar: getch e clrscr*/
#include <string.h> /* para usar: strcpy*/

#define NMAXVOOS 30 /* numero maximo de voo  */
#define TNOMES 20     /* tamanho maximo dos nomes dos clientes */

int main ()
{
    
  int opcao; /* menu - opo digitada pelo usurio */
  int n; /* numero efetivo de voos na execucao do programa - numero de repeticoes*/
  int i; /* contador de repeticao */
  int vetVoo[NMAXVOOS]; /* vetor com os numeros dos voos existentes */
  int vetListDisp[NMAXVOOS]; /* vetor com a quantidade de lugares disponiveis nos voos */
  int identClient; /* numero da identidade de um cliente */
  char nomeClient[TNOMES]; /* nome de um cliente */
  int numVoo; /* numero do voo desejado */  
  int apont; /* indice da posicao do voo desejado */ 
  char atende;

  do
  {
    //clrscr(); // limpa a janela do usuario
    //system ("clear");
	printf ("\n\n\t\t|''''''''''''''''''''''''''''''''''''''''''''''''''''|"); 
	printf ("\n\t\t|     Programa Para Reserva de Passagens Aereas      |");
	printf ("\n\t\t|....................................................|");
	printf ("\n\n1 - Cadastrar os numeros dos voos existentes, e");
	printf ("\n  - Cadastrar quantidade de lugares disponiveis nos voos");
	printf ("\n2 - Atendimento aos clientes" );
	printf ("\n3 - Sair do programa");
	printf ("\n\nDigite uma opcao: ");
	scanf ("%d", &opcao);
	
	switch (opcao)
	{
	  case 1:  
        //define valores iniciais
        printf("\nDigite o numero efetivo de voos (n): ");
        scanf("%d", &n);
        for(i=0; i<n; i++)//for1
        {
          printf("\nDados dos voos %d:",i+1);
          printf("\n\tNumero: ");
          scanf("%d",&vetVoo[i]);
          printf("\tLugares Disponiveis : ");
          scanf("%d", &vetListDisp[i]);
        }//for1
        break;
	  case 2:  
        //Atender clientes	
        do
        {
          //clrscr(); // limpa a janela do usuario
          //system ("clear");
          printf ("\n\nDados do pedido do cliente:");
          printf("\n\tNumero da identidade : ");
          scanf("%d", &identClient);
          printf("\tNome: ");
          //flushall();
          //fflush(stdin);
          getchar();
          gets(nomeClient);
          printf("\tNumero do voo: ");
          scanf("%d",&numVoo);
          //verificar a existencia do voo
          i=0;
          while ((i<n) && (numVoo != vetVoo[i]))
          {
            i = i + 1;
          }
          if(vetVoo[i] == numVoo)
          {
            apont = i;	
          }
          else
          {
            printf("\nVoo %d: inexistente", numVoo);
            apont = -1;
          }              
          //verificar disponibilidade de lugares no voo
          if(apont != -1)
          {  
            if(vetListDisp[apont] >0)
            {
              printf("\n\n\tPassagem reservada para:");
              printf("\n\tNumero da identidade : %d", identClient);
              printf("\n\tNome: %s", nomeClient);
              printf("\n\tNumero do voo: %d", numVoo);
              vetListDisp[apont] = vetListDisp[apont] - 1;	
            }
            else
            {
              printf("\n\tVoo de numero: %d estah lotado", numVoo);
            }
          } 
          printf ("\n\nDeseja atender outro cliente ?");
          printf ("\nTeclar <enter> - para Sim, ou");
          printf ("\n         <esc> - para Nao");
          atende = getch(); //leitura da tecla teclada, sem teclar o <enter>
        }while (atende == 13); //fim - do-while 
        break;
	  default:
        if(opcao!=3) 
		  printf ("\nOpcao Invalida");
		}	       
    /*O programa s termina quando o usurio digitar 3, pois a condio para que
    o lao do-while continue  que a opo digitada pelo usurio seja diferente de 3. 
    Enquanto isso no ocorrer, o menu de opes continuar sendo mostrado na tela.*/
  }while (opcao != 3);
	
  return 0;
}
